/*
 * This program connects to the http server from a privilege port
 * in order to signal it to shutdown.
 *
 * Usage:
 *      $ shutdown local-port seconds [[host:]port ...]
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unixio.h>
#include <errno.h>
#include <types.h>
#include <socket.h>
#include <in.h>
#include <netdb.h>
#include <descrip.h>
int main ( int argc, char **argv )
{
    int mgr_port, status, sd, i, j, timeout, rem_port, CLI$GET_VALUE();
    char *target;
    char command_line[1000]; $DESCRIPTOR(cmd_dx,command_line);
    $DESCRIPTOR("entity", "$LINE");
    struct sockaddr local, remote;
    struct hostent *hostinfo;
    char remote_host[256];

    j = 0;
    status = CLI$GET_VALUE ( &entity, &cmd_dx, &j );
    if ( (status&1) == 1 ) {
	command_line[j] = '\0';
	printf("command line: '%s'\n", command_line );
    } else exit ( status );
    /*
     * extract arguments from command line.
     */
    if ( argc < 3 ) {
	fprintf(stderr,"Missing arguments, usage:\n");
	fprintf(stderr,"   $ shutdown local-port seconds [host:]port ...\n");
	exit ( 1 );
    }
    mgr_port = atoi ( argv[1] );
    if ( mgr_port <= 0 ) {
	fprintf(stderr,"Invalid port number\n" );
	exit ( 1 );
    } else if (mgr_port > 1023) 
	fprintf(stderr,"local port is not privileged\n");

    timeout = atoi ( argv[2] );
    /*
     * Send command to all targets, default if none specified.
     */
    if ( argc == 3 ) target = "localhost:80";
    else target = argv[3];

    for ( i = 3; target; ) {
	/*
	 * Parse target.
	 */
	remote_host[255] = '\0';
	for ( j = 0; j < sizeof(remote_host)-1; j++ ) {
	    remote_host[j] = *target++;
	    if ( *target == ':' ) {
		rem_port = atoi ( target+1 );
		remote_host[j+1] = '\0';
		break;
	    } else if ( *target == '\0' ) {
		rem_port = atoi ( remote_host );
		strcpy ( remote_host, "localhost" );
		break;
	    }
	}
	/*
	 * Create socket on privileged port.
	 */
	sd = socket ( AF_INET, SOCK_STREAM, 0 );
	if ( sd < 0 ) {
	    fprintf(stderr,"Error creating socket: %s\n", strerror(errno) );
	}
	local.sa_family = AF_INET;
	for ( j = 0; j < sizeof(local.sa_data); j++ ) local.sa_data[0] = '\0';
	local.sa_data[0] = mgr_port >> 8;
	local.sa_data[1] = (mgr_port&255);
	status = bind ( sd, &local, sizeof ( local ) );
	/*
	 * Lookup host.
	 */
	hostinfo = gethostbyname ( remote_host );
	if ( !hostinfo ) {
	    fprintf(stderr, "Could not find host '%s'\n", remote_host );
	    continue;
	}
	remote.sa_family = hostinfo->h_addrtype;
	for ( j = 0; j < hostinfo->h_length; j++ ) {
	    remote.sa_data[j+2] = hostinfo->h_addr_list[0][j];
	}
	remote.sa_data[0] = rem_port >> 8;
	remote.sa_data[1] = (rem_port&255);
	/*
	 * Connect to remote host.
	 */
	status = connect ( sd, &remote, sizeof(remote) );
	if ( status == 0 ) {
	    int response[20], length;
	    /* Send shutdown parameters and read response */
	    status = write ( sd, &timeout, sizeof(timeout) );
	    length = 0;
	    status = read ( sd, &response, sizeof(response) );
	    printf("Target %s response: %d, sts=%d\n", 
		target, response[0], status );
	} else {
	    fprintf(stderr, "error connecting to '%s': %d/%d\n", remote_host,
		status, errno );
	}
	close ( sd );
	/*
	 * Update target string for next pass through loop.
	 */
	i++;
	if ( i < argc ) target = argv[i]; else target = (char *) 0;
    }
    return 1;
}
